/*
 *  Copyright (C) 2007 Rob Cliff.  All Rights Reserved.
 *  Copyright (C) 2007 Savage Minds Ltd.  All Rights Reserved.
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 */

#ifndef VNCVIEWERDOCUMENT_H
#define VNCVIEWERDOCUMENT_H

#include <AknDoc.h>
#include <in_sock.h>

/**
The connection settings
*/
class TConnectionSettings
	{
public:
	TConnectionSettings();

	TBuf<50>	iVia;
	TBuf<200>	iAddress;
	TInt 		iPort;	
	TBool		iViewOnly;
	TBool		iShared;
	TBool		iCursor;
	TBool		iX11Cursor;
	TBool		iFullScreen;
	TInt		iDepth;
	TInt		iEncodings;
	TInt		iCompression;
	TInt		iQuality;
	TBool		iJpeg;
	TBool		iPrivacyWarning;		
	TBool		iConnectionWarning;		
	};

/**
This class represents the document in hello world application,
For an UIQ application to work properly the document class need to be
derived from CQikDocument.
*/
class CVNCViewerDocument : public CAknDocument
	{
public:
	static CVNCViewerDocument* NewL(CAknApplication& aApp);
	virtual ~CVNCViewerDocument();
	
	void SaveIniFileL();
	TConnectionSettings& Settings(); 
	const TDesC& CmdParams();

	// Convert settings to command line parameters
	void SetupCmdParamsL();
			
private: 
	// from CQikDocument
	CEikAppUi* CreateAppUiL();
	
	CVNCViewerDocument(CAknApplication& aApp);
	void ConstructL();
	
	// Open and read the Ini file
	void ReadIniFileL();
	
	
private:
	TConnectionSettings	iSettings;
	TBuf<400>			iCmdParams;
	};

#endif // VNCVIEWERDOCUMENT_H
