/*
 *  Copyright (C) 2007 Rob Cliff.  All Rights Reserved.
 *  Copyright (C) 2007 Savage Minds Ltd.  All Rights Reserved.
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 */


#ifndef VNCSCALEDIALOG_H
#define VNCSCALEDIALOG_H

#include <QikSimpleDialog.h>

/**
Callback class when the text is complete
*/
class MScale
	{
public:
	virtual void ScaleL(TInt aCmd, const TReal aScale) = 0;	
	};
	
/**
Simple dialog that is used as for text entry to send to the server
*/
class CVNCScaleDialog : public CQikSimpleDialog
    {
public:
	static CVNCScaleDialog* NewL(TReal aScale);
	virtual ~CVNCScaleDialog();
	void HandleCommandL(CQikCommand& aCommand);
	void PreLayoutDynInitL();
	TCoeInputCapabilities InputCapabilities() const;
	
	const TReal ValueL();
	void Cancel();
	
private:
	CVNCScaleDialog(TReal aScale);
	void ConstructL();
	
private:
	/** Reference to the command manager that are used to change commands with. */
	CQikCommandManager& iCmdManager;
	TReal 				iInitialScale;
	};

/**
Active object to handle the send text dialog
*/
class CScaleActive : public CActive
	{
public:
	static CScaleActive* NewL(MScale &aScaleCallback, TReal aScale);
	virtual ~CScaleActive();
	
private:
	CScaleActive(MScale &aScaleCallback);
	void ConstructL(TReal aScale);
	
	void RunL();
	void DoCancel();
	
private:
	MScale& 				iScaleCallback;
	CVNCScaleDialog*		iDialog;
	};

#endif // VNCSCALEDIALOG_H
