/*
 *  Copyright (C) 2007 Rob Cliff.  All Rights Reserved.
 *  Copyright (C) 2007 Savage Minds Ltd.  All Rights Reserved.
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 */


#ifndef VNCVIEWERSETTINGSVIEW_H
#define VNCVIEWERSETTINGSVIEW_H

#include <QikMultiPageViewBase.h>
#include <QUiConfigClient.h>

/**
The settings view, consisting of 5 pages of controls.
*/
class CVNCViewerSettingsView : public CQikMultiPageViewBase
	{
public:
	static CVNCViewerSettingsView* NewLC(CQikAppUi& aAppUi);
	~CVNCViewerSettingsView();
	
	// from CQikViewBase
	TVwsViewId ViewId()const;
	void HandleCommandL(CQikCommand& aCommand);
	
	void HandleControlEventL(CCoeControl *aControl, TCoeEvent aEventType);	
	
protected: // from CQikViewBase
	void ViewActivatedL(const TVwsViewId& aPrevViewId, const TUid aCustomMessageId, const TDesC8& aCustomMessage);
	void ViewConstructL(); 

	// Save the settings for the document	
	void SaveSettingsL();
	
private:
	CVNCViewerSettingsView(CQikAppUi& aAppUi);
	void ConstructL();
	
private:
	TBool iPrivacyDone;
	};


#endif // VNCVIEWERSETTINGSVIEW_H
