/*
 *  Copyright (C) 2007 Rob Cliff.  All Rights Reserved.
 *  Copyright (C) 2007 Savage Minds Ltd.  All Rights Reserved.
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 */

/*
 * x11JpegConvert.h - A Jpeg converter
 */

#ifndef __X11JpegConverter_H__
#define __X11JpegConverter_H__

// Includes
#include "x11.h"
#include <w32std.h>
#include <badesca.h>

// Different header file on UIQ3 and S60 v3
#if defined(__SERIES60V3__)
#include <ImageConversion.h>
#else
#include <ICLExif.h>
#endif

/*
 * A JPEG converter
 */
class CJpegConverter : public CActive
	{
public:
	// Convert the JPEG
	static void ConvertL(RFs& aFs, const TDesC8& aData, CFbsBitmap* aBitmap);
	
private:
	CJpegConverter();
	virtual ~CJpegConverter();
	void InternalConvertL(RFs& aFs, const TDesC8& aData, CFbsBitmap* aBitmap);

	void RunL();
	void DoCancel();
	TInt ErrorCode() {  return iStatus.Int(); };

private:
	CImageDecoder*	iDecoder;
	};

#endif // X11JpegConverter
