/*
 *  Copyright (C) 2007 Rob Cliff.  All Rights Reserved.
 *  Copyright (C) 2007 Savage Minds Ltd.  All Rights Reserved.
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 */

/*
 * x11NVPair.h - A name value pair
 */

#ifndef __X11NVPair_H__
#define __X11NVPair_H__

#include <e32base.h>

/*
 * Class to store a name-value pair
 */
class CNVPairDes : public CBase
	{
public:
	static CNVPairDes* NewL(const TDesC8& aName, const TDesC8& aValue);
	static CNVPairDes* NewL(const TDesC8& aName);
	virtual ~CNVPairDes(); 

	void SetValueL(const TDesC8& aValue);
	const TDesC8& Name();
	const TDesC8& Value(); 
		
private:
	CNVPairDes() { }
	void ConstructL(const TDesC8& aName, const TDesC8& aValue);

private:
	HBufC8* iName;
	HBufC8* iValue;
	};	

#endif // __X11NVPair_H__
